Subject: Re: Revised LFB input/output text

From: Alex Audu <[email-masked]>
Date: Wed, 5 May 2004 20:19:31 EDT

Hello Jamal,

I am not sure your view will work for a Classifier with one input and
multiple outputs. If I
have to assign different QoS to incoming packets due to some criteria which
are computed
in real-time, it seems fair to say that the meta-data so determined will be
used to separate
the packet stream into different queues for proper treatment.  Such meta-data
can only be
determined dynamically, and I don't see how you can pre-determine it.

Regards,
Alex.

In a message dated 5/5/2004 2:27:09 PM Central Standard Time, [email-masked]
writes:
On Wed, 2004-05-05 at 11:07, Joel M. Halpern wrote:
> From a topological point of view, the two are the same.
> They are each an LFB instance of an LFB class (two different classes).
> They each have one input, with meta-data tagging, and two outputs.
> One class is defined to use the meta-data to decide which of the two
> outputs to send the packet to.
>
> The other is defined to always send the packet on output 1, and sometimtes
> (depending upon the metadata) to make a copy of the packet, modify the
> meta-data and send the copy on output two.
>
> I would expect the outputs to have very different names in the two LFB
> class definitions.  The first one might have outputs named IPv4 and IPv6,
> while the second might have outputs named normal and LEA.
>
> Connecting those outputs up properly is the job of the CE>

Yes, the above should work.

I think we have _different_ views of how things should work - which is
almost implementation detailed. What worries me is that the definition
of LFB classes, when the time comes, is going to be very contentious (at
least with me).
You seem to have a lot of dependicies on metadata - which may explain a
lot of our disagreements.
I can live with the above, just dont impose the usage of metadata on me.

my view, to summarize:
All LFBs can be looked at as reentrant clones of the LFB class. You can
instantiate an LFB but it is useless unless bound to a packet
path/topology. Once the CE creates the LFB topology (connects inputs to
outputs), then theres no dependency on metadata to decide where to go
next. The path decision is based on processing which is driven by state
primarily. State could actually be static internal data like "always
drop".

Maybe i should present again over a concall to the design team what i
presented at Mineapolis. or maybe i should output a draft.

cheers,
jamal